<?php            
defined('C5_EXECUTE') or die(_("Access Denied."));
class SkybluesofaSocialShareBlockController extends BlockController {
	
	var $pobj;

	protected $btTable = 'btSkybluesofaSocialShare';
	protected $btNetworksTable = 'btSkybluesofaSocialSharedNetworks';
	protected $btInterfaceWidth = "580";
	protected $btInterfaceHeight = "450";
	protected $db = null;
	protected $thumbnail_handle = array('page_thumbnail','thumbnail');
			
	/** 
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription() {
		return t("Displays social sharing buttons on your site");
	}
	
	public function getBlockTypeName() {
		return t("Social Share");
	}		
	
	
	public function __construct($obj = null) {		
		parent::__construct($obj);
		$this->db = Loader::db();
	}
	
	public function view() {
		if (empty($this->layout)) $this->layout = 'horizontal';
		$this->set('layout', $this->layout);
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('bID',$this->bID);

		$currentPage = Page::getCurrentPage();
		Loader::helper('navigation');
		
		$this->set('sbsss_cID', $currentPage->getCollectionID());
		$this->set('sbsss_pageURL', NavigationHelper::getLinkToCollection($currentPage, true));
		$this->set('sbsss_pageTitle', $currentPage->getCollectionAttributeValue('meta_title') ? $currentPage->getCollectionAttributeValue('meta_title') : $currentPage->getCollectionName());
		$this->set('sbsss_pageDescription', $currentPage->getCollectionAttributeValue('meta_description') ? $currentPage->getCollectionAttributeValue('meta_description') : '');
		$this->set('submitBorderColor', str_replace("#","",$this->alter_brightness($this->record->emailShareSubmitColor, -20)));
		$this->set('numberOfEmails', $this->db->GetOne("SELECT count(id) FROM btSkybluesofaSharedEmails WHERE cID=?", array($currentPage->getCollectionID())));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}

	function add() {
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}
	
	function edit() {
		$this->set('networks', $this->getNetworks());
		$this->set('sharedNetworks', $this->getSharedNetworks($this->bID));
		$this->set('pinterest_image', $this->getPageThumbnail());
	}
	
	function getPageThumbnail() {
		Loader::model('file');
		$currentPage = Page::getCurrentPage();
		foreach ($this->thumbnail_handle as $thumbnail_handle) {
			$thumbnail = $currentPage->getAttribute($thumbnail_handle);
			if(is_object($thumbnail)){
				$fID = $thumbnail->getFileID();
				$imageUrl = BASE_URL.File::getRelativePathFromID($fID);
				if ($imageUrl) return $imageUrl;
			}
		}
		return false;
	}
	
	function action_shareviaemail() {
		$cID = $_REQUEST['cID'];
		$pageURL = $_REQUEST['pageURL'];
		$pageTitle = $_REQUEST['pageTitle'];
		$pageDescription = $_REQUEST['pageDescription'];
		$fromEmailAddress = $_REQUEST['emailFrom'];
		$fromName = $fromEmailAddress;
		$toEmailAddress = $_REQUEST['emailTo'];
		$toName = $toEmailAddress;
		$comment = $_REQUEST['comment'];
		
		$db = Loader::db();
		$vals = array($toName, $toEmailAddress, $fromName, $fromEmailAddress, $cID, $pageURL, $pageTitle, $comment, date('Y-m-d H:i:s'));
		$db->execute('INSERT INTO btSkybluesofaSharedEmails (toName, toEmail, fromName, fromEmail, cID, url, title, comment, date) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', $vals);

		$mh = Loader::helper('mail');
		$mh->to($toEmailAddress, $toName);
		$mh->addParameter('comment', $comment);
		$mh->addParameter('url', $pageURL);
		$mh->addParameter('title', $pageTitle);
		$mh->addParameter('description', $pageDescription);
		$mh->from($fromEmailAddress, $fromName);
		$mh->load('share_page', 'skybluesofa_social_share');
		$mh->setSubject($fromName. t(' has shared this with you: '). $pageTitle);
		//echo $mh->bodyHTML.'<br>';
		@$mh->sendMail();
		
		print $db->GetOne("SELECT count(id) FROM btSkybluesofaSharedEmails WHERE cID=?", array($cID));
		die();
	}
	
	/*
	 * save block config
	 */ 
	public function save($args) {
		$args['emailShareBackgroundColor'] = empty($args['emailShareBackgroundColor']) ? '0A9AB9' : $args['emailShareBackgroundColor'];
		$args['emailShareSubmitColor'] = empty($args['emailShareSubmitColor']) ? 'ffa145' : $args['emailShareSubmitColor'];
		$args['floating_offset'] = empty($args['floating_offset']) ? '0' : $args['floating_offset'];
		parent::save($args);
		$this->saveSharedNetworks($this->bID, $args);
	}
	
	function duplicate($newBID) {
		parent::duplicate($newBID);
		$this->duplicateSharedNetworks($newBID);
	}
		
	public function getSharedNetworks($bID) {
        $po = $this->db->GetArray("SELECT * FROM ".$this->btNetworksTable." WHERE ordinal IS NOT NULL AND bID = ? ORDER BY ordinal", array($bID));
        $no = $this->db->GetArray("SELECT * FROM ".$this->btNetworksTable." WHERE ordinal IS NULL AND bID = ? ORDER BY connID", array($bID));
        $res = array_merge($po, $no);
		foreach ($res as $key=>$sharedNetwork) {
			if ($sharedNetwork['network']=='pinterest') {
				$currentPage = Page::getCurrentPage();
				if (empty($sharedNetwork['url'])) {
					Loader::helper('navigation');
					$res[$key]['url'] = NavigationHelper::getLinkToCollection($currentPage, true);
				}
				if (empty($sharedNetwork['dg_description'])) {
					$res[$key]['dg_description'] = $currentPage->getCollectionDescription();
				}
			}
		}
        return $res;
	}
	
	public function saveSharedNetworks($bID, $args) {
		if (!isset($args['sharedNetworks']) || !is_array($args['sharedNetworks'])) {
			return false;
		}
		$this->deleteSharedNetworks($bID);
		$ordinal = 1;
		foreach ($args['sharedNetworks']['network'] as $key=>$value) {
			if ($key && !empty($args['sharedNetworks']['network'][$key])) {
				if (in_array($args['sharedNetworks']['network'][$key], $this->getNetworks())) {
					$sharedNetwork['bID'] = $bID;
					$sharedNetwork['ordinal'] = $ordinal;
					$sharedNetwork['network'] = $args['sharedNetworks']['network'][$key];
					$sharedNetwork['title'] = $args['sharedNetworks']['title'][$key];
					$sharedNetwork['url'] = $args['sharedNetworks']['url'][$key];
					$sharedNetwork['tw_recommend'] = $args['sharedNetworks']['tw_recommend'][$key];
					$sharedNetwork['fb_verb'] = $args['sharedNetworks']['fb_verb'][$key];
					$sharedNetwork['dg_topic'] = $args['sharedNetworks']['dg_topic'][$key];
					$sharedNetwork['dg_description'] = $args['sharedNetworks']['dg_description'][$key];
					$this->addSharedNetwork($bID, $sharedNetwork);
					$ordinal++;
				}
			}
		}
	}
	
	function duplicateSharedNetworks($newBID) {
		$b=$this->getBlockObject(); 
		$c=$b->getBlockCollectionObject();	 
		 
		$res = $this->db->query("select * from " . $this->btTable . " where bID = ?", array($this->bID));
		$existingBlock = $res->fetchRow();
		
		if(count($existingBlock)>0){ 
			$oldBID=$existingBlock['bID'];
			
			$res = $this->db->GetArray("SELECT * FROM ".$this->btNetworksTable." WHERE bID=?", array($this->bID));
			$existingSharedNetworks = array('sharedNetworks'=>array());
			$existingSharedNetworks['sharedNetworks']['network'][]=null;
			$existingSharedNetworks['sharedNetworks']['title'][]=null;
			$existingSharedNetworks['sharedNetworks']['url'][]=null;
			$existingSharedNetworks['sharedNetworks']['tw_recommend'][]=null;
			$existingSharedNetworks['sharedNetworks']['fb_verb'][]=null;
			$existingSharedNetworks['sharedNetworks']['dg_topic'][]=null;
			$existingSharedNetworks['sharedNetworks']['dg_description'][]=null;
			foreach ($res as $key=>$sharedNetwork) {
				$existingSharedNetworks['sharedNetworks']['network'][]=$sharedNetwork['network'];
				$existingSharedNetworks['sharedNetworks']['title'][]=$sharedNetwork['title'];
				$existingSharedNetworks['sharedNetworks']['url'][]=$sharedNetwork['url'];
				$existingSharedNetworks['sharedNetworks']['tw_recommend'][]=$sharedNetwork['tw_recommend'];
				$existingSharedNetworks['sharedNetworks']['fb_verb'][]=$sharedNetwork['fb_verb'];
				$existingSharedNetworks['sharedNetworks']['dg_topic'][]=$sharedNetwork['dg_topic'];
				$existingSharedNetworks['sharedNetworks']['dg_description'][]=$sharedNetwork['dg_description'];
			}
			$this->saveSharedNetworks($newBID, $existingSharedNetworks);
		} else {
			return 0;
		}
	}
	
	public function addSharedNetwork($bID, $newSharedNetwork) {
		if (!is_array($newSharedNetwork)) {
			return false;
		}
		$sharedNetwork = array('bID'=>$bID, 'ordinal'=>null, 'network'=>null, 'title'=>null, 'url'=>null, 'tw_recommend'=>null, 'fb_verb'=>null, 'dg_topic'=>null, 'dg_description'=>null);
		foreach ($sharedNetwork as $key=>$value) {
			if (array_key_exists($key, $newSharedNetwork)) {
				$sharedNetwork[$key] = $newSharedNetwork[$key];
			}
		}
	
		$res = $this->db->Execute("INSERT INTO ".$this->btNetworksTable." (bID, ordinal, network, title, url, tw_recommend, fb_verb, dg_topic, dg_description) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)", $sharedNetwork);
		return $res;
	}
	
	public function deleteSharedNetworks($bID) {
        $res = $this->db->Execute("DELETE FROM ".$this->btNetworksTable." WHERE bID = ?", array($bID));
        return $res;
	}
	
	public function getNetworks() {
		if (!isset($this->networks) || !$this->networks) {
			//$this->networks['about.me'] = "aboutdotme";
			//$this->networks['AIM'] = "aim";
			//$this->networks['Amazon'] = "amazon";
			//$this->networks['BBC ID'] = "bbcid";
			//$this->networks['Bebo'] = "bebo";
			//$this->networks['Creative Commons'] = "creativecommons";
			//$this->networks['Delicous'] = "delicious";
			$this->networks['Digg'] = "digg";
			//$this->networks['Dopplr'] = "dopplr";
			//$this->networks['Dribbble'] = "dribbble";
			//$this->networks['eBay'] = "ebay";
			$this->networks['E-mail'] = "email";
			$this->networks['Facebook'] = "facebook";
			//$this->networks['Feed'] = "feed";
			//$this->networks['FFFFound'] = "ffffound";
			//$this->networks['Fire Eagle'] = "fireeagle";
			//$this->networks['Flickr'] = "flickr";
			//$this->networks['FormSpring'] = "formspring";
			//$this->networks['Forrst'] = "forrst";
			//$this->networks['Foursquare'] = "foursquare";
			//$this->networks['GeoTag'] = "geotag";
			//$this->networks['Get Satisfaction'] = "getsatisfaction";
			//$this->networks['Github'] = "github";
			//$this->networks['GoodReads'] = "goodreads";
			//$this->networks['Google'] = "google";
			$this->networks['Google+'] = "google+";
			//$this->networks['Google Talk'] = "google-talk";
			//$this->networks['Gowalla'] = "gowalla";
			//$this->networks['HuffDuffer'] = "huffduffer";
			$this->networks['Hyves'] = "hyves";
			//$this->networks['Identi.ca'] = "identica";
			//$this->networks['iLike'] = "ilike";
			//$this->networks['IMDb'] = "imdb";
			//$this->networks['iTunes'] = "itunes";
			//$this->networks['Lanyrd'] = "lanyrd";
			//$this->networks['Last.fm'] = "lastfm";
			$this->networks['LinkedIn'] = "linkedin";
			//$this->networks['Meetup'] = "meetup";
			//$this->networks['Messenger'] = "messenger";
			//$this->networks['Mixx'] = "mixx";
			//$this->networks['MySpace'] = "myspace";
			//$this->networks['NetVibes'] = "netvibes";
			//$this->networks['NewsVine'] = "newsvine";
			//$this->networks['Nike+'] = "nikeplus";
			//$this->networks['OpenID'] = "openid";
			//$this->networks['Orkut'] = "orkut";
			//$this->networks['PayPal'] = "paypal";
			//$this->networks['Picasa'] = "picasa";
			//$this->networks['PinBoard'] = "pinboard";
			$this->networks['Pinterest'] = "pinterest";
			//$this->networks['Plancast'] = "plancast";
			//$this->networks['Posterous'] = "posterous";
			//$this->networks['Rdio'] = "rdio";
			//$this->networks['Readernaut'] = "readernaut";
			$this->networks['Reddit'] = "reddit";
			//$this->networks['Share'] = "share";
			//$this->networks['Skype'] = "skype";
			//$this->networks['SlideShare'] = "slideshare";
			//$this->networks['Speaker Deck'] = "speakerdeck";
			//$this->networks['Spotify'] = "spotify";
			$this->networks['StumbleUpon'] = "stumbleupon";
			//$this->networks['Tumblr'] = "tumblr";
			$this->networks['Twitter'] = "twitter";
			//$this->networks['Upcoming'] = "upcoming";
			//$this->networks['vCard'] = "vcard";
			//$this->networks['Viddler'] = "viddler";
			//$this->networks['Vimeo'] = "vimeo";
			//$this->networks['Website'] = "website";
			//$this->networks['Wikipedia'] = "wikipedia";
			//$this->networks['xBox Live'] = "xbox";
			//$this->networks['Xing'] = "xing";
			//$this->networks['Yahoo!'] = "yahoo";
			//$this->networks['Yahoo! Messenger'] = "yahoo-messenger";
			//$this->networks['Yelp'] = "yelp";
			//$this->networks['YouTube'] = "youtube";
			//$this->networks['Zootool'] = "zootool";
		}
		return $this->networks; 	
	}
	function alter_brightness($colourstr, $steps) {
		$colourstr = str_replace('#','',$colourstr);
		$rhex = substr($colourstr,0,2);
		$ghex = substr($colourstr,2,2);
		$bhex = substr($colourstr,4,2);
	
		$r = hexdec($rhex);
		$g = hexdec($ghex);
		$b = hexdec($bhex);
	
		$r = max(0,min(255,$r + $steps));
		$g = max(0,min(255,$g + $steps));
		$b = max(0,min(255,$b + $steps));
	
		return '#'.dechex($r).dechex($g).dechex($b);
	}
}

?>